import java.io.*;
import java.util.*;

public class test1 {


	static boolean used[];
	static ArrayList[] neighbours;
	int startnode = 0;

	@SuppressWarnings("static-access")
	public int dfs(int node) {
		if(used[node]) {
			return -1;
		}
		used[node] = true;
		if(neighbours[node].size() == 1 && node != startnode) {
			return 0;
		}
		ArrayList<Integer> sums = new ArrayList<>();
		for(Object i: neighbours[node]) {
			if(!used[(int) i]) {
				sums.add(dfs((int) i));
			}
		}
		if(node == startnode) {
			int max = 0;
			int max2 = -1;
			for(int i = 0; i < sums.size(); i++) {
				if(max < sums.get(i)) {
					max2 = max;
					max = sums.get(i);
					continue;
				}
				if(max2 < sums.get(i)) {
					max2 = sums.get(i);
				}
			}
			return max + max2 + 2;
		}
		if(neighbours[node].size() >= 2 && node != 0) {
			int max = -1;
			for(int i = 0; i < sums.size(); i++) {
				max = Math.max(max, sums.get(i));
			}
			return max + 1;
		} else {
			return 0;
		}
	}

	@SuppressWarnings({ "unchecked", "rawtypes", "static-access" })
	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		 neighbours = new ArrayList[n];
		for(int i = 0; i < n; i++) {
			neighbours[i] = new ArrayList<Integer>();
		}
		for (int i = 1; i < n; i++) {
			int p = nextInt() - 1;
			neighbours[i].add(p);
			neighbours[p].add(i);
		}
		used = new boolean[n];
		int max = 0;
		for(int i = 0; i < n; i++) {
			used = new boolean[n];
			startnode = i;
			int cur = dfs(i);
			if(cur > max) {
				max = cur;
			}
		}
		System.out.println(max + 1);

	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in)); 
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new test1().run();
	}

}